import * as React from 'react';
import {
  cleanup,
  render,
  screen,
} from '@testing-library/react';
import userEvent from '@testing-library/user-event';
import { TextControl } from '@tesseract-design/web-base';
import {
  vi,
  expect,
  describe,
  it,
  afterEach,
} from 'vitest';
import matchers from '@testing-library/jest-dom/matchers';
import {
  MultilineTextInput,
  MultilineTextInputDerivedElement,
} from '.';

expect.extend(matchers);

describe('TextInput', () => {
  afterEach(() => {
    cleanup();
  });

  it('renders a textbox', () => {
    render(
      <MultilineTextInput />,
    );
    const textbox = screen.getByRole('textbox');
    expect(textbox).toBeInTheDocument();
  });

  it('renders a border', () => {
    render(
      <MultilineTextInput
        border
      />,
    );
    const border = screen.getByTestId('border');
    expect(border).toBeInTheDocument();
  });

  it('renders a label', () => {
    render(
      <MultilineTextInput
        label="foo"
      />,
    );
    const textbox = screen.getByLabelText('foo');
    expect(textbox).toBeInTheDocument();
    const label = screen.getByTestId('label');
    expect(label).toHaveTextContent('foo');
  });

  it('renders a hidden label', () => {
    render(
      <MultilineTextInput
        label="foo"
        hiddenLabel
      />,
    );
    const textbox = screen.getByLabelText('foo');
    expect(textbox).toBeInTheDocument();
    const label = screen.queryByTestId('label');
    expect(label).toBeInTheDocument();
    expect(label).toHaveClass('sr-only');
  });

  it('renders a hint', () => {
    render(
      <MultilineTextInput
        hint="foo"
      />,
    );
    const hint = screen.getByTestId('hint');
    expect(hint).toBeInTheDocument();
  });

  it('renders an indicator', () => {
    render(
      <MultilineTextInput
        indicator={
          <div />
        }
      />,
    );
    const indicator = screen.getByTestId('indicator');
    expect(indicator).toBeInTheDocument();
  });

  describe.each`
    size        | inputClassName | hintClassName | indicatorClassName
    ${'small'}  | ${'min-h-10'}  | ${'pr-10'}    | ${'w-10'}
    ${'medium'} | ${'min-h-12'}  | ${'pr-12'}    | ${'w-12'}
    ${'large'}  | ${'min-h-16'}  | ${'pr-16'}    | ${'w-16'}
  `('on $size size', ({
    size,
    inputClassName,
    hintClassName,
    indicatorClassName,
  }: {
    size: TextControl.Size,
    inputClassName: string,
    hintClassName: string,
    indicatorClassName: string,
  }) => {
    it('renders input styles', () => {
      render(
        <MultilineTextInput
          size={size}
        />,
      );

      const input = screen.getByTestId('input');
      expect(input).toHaveClass(inputClassName);
    });

    it('renders label styles with indicator', () => {
      render(
        <MultilineTextInput
          size={size}
          label="foo"
          indicator={<div />}
        />,
      );
      const label = screen.getByTestId('label');
      expect(label).toHaveClass(hintClassName);
    });

    it('renders hint styles when indicator is present', () => {
      render(
        <MultilineTextInput
          size={size}
          hint="hint"
          indicator={<div />}
        />,
      );

      const hint = screen.getByTestId('hint');
      expect(hint).toHaveClass(hintClassName);
    });

    it('renders indicator styles', () => {
      render(
        <MultilineTextInput
          size={size}
          indicator={
            <div />
          }
        />,
      );

      const indicator = screen.getByTestId('indicator');
      expect(indicator).toHaveClass(indicatorClassName);
    });
  });

  it('renders a block textbox', () => {
    render(
      <MultilineTextInput
        block
      />,
    );

    const base = screen.getByTestId('base');
    expect(base).toHaveClass('block');
  });

  describe.each`
    variant        | inputClassName   | hintClassName
    ${'default'}   | ${'pl-4'}        | ${'bottom-0 pl-4 pb-1'}
    ${'alternate'} | ${'pl-1.5'}      | ${'top-0.5'}
  `('on $variant style', ({
    variant,
    inputClassName,
    hintClassName,
  }: {
    variant: TextControl.Variant,
    inputClassName: string,
    hintClassName: string,
  }) => {
    it('renders input styles', () => {
      render(
        <MultilineTextInput
          variant={variant}
        />,
      );

      const input = screen.getByTestId('input');
      expect(input).toHaveClass(inputClassName);
    });

    it('renders hint styles', () => {
      render(
        <MultilineTextInput
          variant={variant}
          hint="hint"
        />,
      );

      const hint = screen.getByTestId('hint');
      expect(hint).toHaveClass(hintClassName);
    });
  });

  it('handles change events', async () => {
    const onChange = vi.fn().mockImplementationOnce(
      (e: React.ChangeEvent<MultilineTextInputDerivedElement>) => {
        e.preventDefault();
      },
    );
    render(
      <MultilineTextInput
        onChange={onChange}
      />,
    );
    const textbox: HTMLInputElement = screen.getByRole('textbox');
    await userEvent.type(textbox, 'foobar');
    expect(onChange).toBeCalled();
  });

  it('handles input events', async () => {
    const onInput = vi.fn().mockImplementationOnce(
      (e: React.SyntheticEvent<MultilineTextInputDerivedElement>) => {
        e.preventDefault();
      },
    );
    render(
      <MultilineTextInput
        onInput={onInput}
      />,
    );
    const textbox: HTMLInputElement = screen.getByTestId('input');
    await userEvent.type(textbox, 'foobar');
    expect(onInput).toBeCalled();
  });
});
